> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.emnify.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.emnify.com/_mcp/server.

# List operation for eUICC

GET https://cdn.emnify.net/api/v1/euicc/{euicc_id}/operation

List all operations of a specific IoT eUICC.
This route returns HTTP 404 error for non-IoT eUICCs.
Operations data is retained for 90 days.


Reference: https://docs.emnify.com/developers/api/euicc-operation/list-operation

## Authentication

- `Authorization` header (bearer token, required) — An auth_token should be provided to authenticate a session. To obtain an auth_token, see the POST request to `/api/v1/authenticate`.

## Request

### Path parameters

- `euicc_id` (integer, required)

### Query parameters

- `page` (integer, optional, default: 1) — Page number (1-based).
- `per_page` (integer, optional, default: 100) — Items per page.
- `q` (string, optional) — Filter parameter in `<field>:<criteria>` format. Expects a comma-separated list from the allowed fields: * `id` * `action` * `status` * `iccid_with_luhn`
- `sort` (string, optional) — Sort properties according to a comma separated list from the allowed fields (prefix with `-` for descending): - `id` - `action` - `status` - `iccid_with_luhn` - `creation_date` - `expiry_date` - `finalization_date`

## Response

### 200

Operation list

- `list of EuiccOperation`

## Errors

### 400 Bad Request Error

Bad Request

- `status_code` (integer, required)
- `message` (string, required)

### 401 Unauthorized Error

Unauthorized

- `status_code` (integer, required)
- `message` (string, required)

### 403 Forbidden Error

Forbidden

- `status_code` (integer, required)
- `message` (string, required)

### 404 Not Found Error

Not Found

- `status_code` (integer, required)
- `message` (string, required)

### 500 Internal Server Error

Internal Server Error

- `status_code` (integer, required)
- `message` (string, required)

## Types

### EuiccOperation

- `id` (string, required)
- `action` (OperationAction, required)
- `status` (OperationStatus, required)
- `creation_date` (string, required)
- `last_updated_at` (string, required)
- `user` (UserResponse, required)
- `expiry_date` (string, optional)
- `finalization_date` (string, optional)
- `error` (ErrorResponse, optional)
- `iccid_with_luhn` (string, optional) — Full ICCID including the Luhn check digit

### OperationAction

- `id` (integer, required)
- `description` (string, required)

### OperationStatus

- `id` (integer, required)
- `description` (string, required)

### UserResponse

- `id` (integer, required)
- `name` (string, required)

### ErrorResponse

- `reason` (integer, required)
- `message` (string, required)

## Examples

### Default - List All Operations

**Response**

```json
[
  {
    "id": "11111111-2222-3333-4444-555555555555",
    "action": {
      "id": 3,
      "description": "Enable profile"
    },
    "status": {
      "id": 1,
      "description": "Scheduled"
    },
    "creation_date": "2025-09-25T12:00:00.000Z",
    "last_updated_at": "2025-09-25T12:00:00.000Z",
    "user": {
      "id": 123456,
      "name": "John Doe"
    },
    "expiry_date": "2025-09-25T12:10:00.000Z",
    "iccid_with_luhn": "89883030000123456789"
  }
]
```

**SDK Code**

```python Default - List All Operations
import requests

url = "https://cdn.emnify.net/api/v1/euicc/123456/operation"

querystring = {"page":"1","per_page":"25"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Default - List All Operations
const url = 'https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Default - List All Operations
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Default - List All Operations
require 'uri'
require 'net/http'

url = URI("https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Default - List All Operations
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Default - List All Operations
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Default - List All Operations
using RestSharp;

var client = new RestClient("https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Default - List All Operations
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://cdn.emnify.net/api/v1/euicc/123456/operation?page=1&per_page=25")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Filter by Action

**Response**

```json
[
  {
    "id": "22222222-3333-4444-5555-666666666666",
    "action": {
      "id": 1,
      "description": "Audit eUICC"
    },
    "status": {
      "id": 1,
      "description": "Scheduled"
    },
    "creation_date": "2025-09-25T12:00:00.000Z",
    "last_updated_at": "2025-09-25T12:00:00.000Z",
    "user": {
      "id": 123456,
      "name": "John Doe"
    },
    "expiry_date": "2025-09-25T12:10:00.000Z"
  }
]
```

**SDK Code**

```python Filter by Action
import requests

url = "https://cdn.emnify.net/api/v1/euicc/123456/operation"

querystring = {"q":"action:1"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Filter by Action
const url = 'https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Filter by Action
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Filter by Action
require 'uri'
require 'net/http'

url = URI("https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Filter by Action
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Filter by Action
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Filter by Action
using RestSharp;

var client = new RestClient("https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Filter by Action
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://cdn.emnify.net/api/v1/euicc/123456/operation?q=action%3A1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```